#/*++
#  Copyright (c) 2008, Intel Corporation
#  All rights reserved. 
# 
#  This UEFI SCT ("Software") is furnished under license and may only be used or copied
#  in accordance with the terms of that license UEFI Contributor Agreement.
#  No license, express or implied, by estoppel or otherwise, to any intellectual property
#  rights is granted by this document. The Software is subject to change without notice,
#  and should not be construed as a commitment by Intel Corporation to market, license,
#  sell or support any product or technology. Unless otherwise provided for in the license
#  under which this Software is provided, the Software is provided AS IS, with no warranties
#  of any kind, express or implied. Except as expressly permitted by the Software license,
#  neither Intel Corporation nor its suppliers assumes any responsibility or liability
#  for any errors or inaccuracies that may appear herein.
#--*/
# 
# Module Name:
#   
#     TestCase.tcl
#     
# Abstract:
# 
#     Implementation for EMS output form function
#

if {[info exist OUTPUT_TCL] == 1} {
  return
}
set OUTPUT_TCL 1

# 
# Routine Description:
# 
#   Output a message in output window.
# 
# Arguments:
# 
#   string     :   The message to show
# 
# Returns:
# 
#   None.
# 
proc EmsOutput { string } {
  global GuiBoxs
  EmsShowStatus "output start"
  $GuiBoxs(output) insert end $string
  $GuiBoxs(output) see end
  EmsShowStatus "output end"
  return 
}

# 
# Routine Description:
# 
#   Output an error message in output window.
# 
# Arguments:
# 
#   string     :   The message to show.
# 
# Returns:
# 
#   None.
# 
proc EmsOutputError { string } {
  global GuiBoxs
  $GuiBoxs(output) insert end $string gui_output_tags(error)
  $GuiBoxs(output) see end 
  update
  return 
}

# 
# Routine Description:
# 
#   Output an highlight message in output window.
# 
# Arguments:
# 
#   string     :   The message to show.
# 
# Returns:
# 
#   None.
# 
proc EmsOutputHighLight { string } {
  global GuiBoxs
  $GuiBoxs(output) insert end $string gui_output_tags(highlight)
  $GuiBoxs(output) see end 
  update
  return 
}

# 
# Routine Description:
# 
#   Clean up output window.
# 
# Arguments:
# 
#   None.
# 
# Returns:
# 
#   None.
# 
proc EmsClearOutput { } {
  global GuiBoxs
  $GuiBoxs(output) delete 1.0 end 
}
