/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Copyright (c) 2006, Intel Corporation
All rights reserved. 

This UEFI SCT ("Software") is furnished under license and may only be used or copied
in accordance with the terms of that license UEFI Contributor Agreement.
No license, express or implied, by estoppel or otherwise, to any intellectual property
rights is granted by this document. The Software is subject to change without notice,
and should not be construed as a commitment by Intel Corporation to market, license,
sell or support any product or technology. Unless otherwise provided for in the license
under which this Software is provided, the Software is provided AS IS, with no warranties
of any kind, express or implied. Except as expressly permitted by the Software license,
neither Intel Corporation nor its suppliers assumes any responsibility or liability
for any errors or inaccuracies that may appear herein. 

Module Name:

  SimpleNetworkENTSTestCase.h

Abstract:

--*/

#ifndef _SIMPLENETWORK_ENTS_TESTCASE_H_
#define _SIMPLENETWORK_ENTS_TESTCASE_H_

#include "Efi.h"
#include "EfiDriverlib.h"
#include "EntsProtocol.h"
#include "Eas.h"
#include "EntsLib.h"
#include "SimpleNetwork.h"

EFI_STATUS
SimpleNetworkStart_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

  SimpleNetwork Start Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
;

EFI_STATUS
SimpleNetworkStop_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

  SimpleNetwork Stop Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
;

EFI_STATUS
SimpleNetworkInitialize_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

  SimpleNetwork Initialize Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
;

EFI_STATUS
SimpleNetworkReset_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

  SimpleNetwork Reset Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
;

EFI_STATUS
SimpleNetworkShutdown_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

  SimpleNetwork Shutdown Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
;

EFI_STATUS
SimpleNetworkReceiveFilters_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

  SimpleNetwork ReceiveFilters Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
;

EFI_STATUS
SimpleNetworkStationAddress_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

  SimpleNetwork StationAddress Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
;

EFI_STATUS
SimpleNetworkStatistics_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

  SimpleNetwork Statistics Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
;

EFI_STATUS
SimpleNetworkMCastIPToMAC_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

  SimpleNetwork MCastIPToMAC Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
;

EFI_STATUS
SimpleNetworkNvData_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

  SimpleNetwork NvData Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
;

EFI_STATUS
SimpleNetworkGetStatus_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

  SimpleNetwork GetStatus Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
;

EFI_STATUS
SimpleNetworkTransmit_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

  SimpleNetwork Transmit Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
;

EFI_STATUS
SimpleNetworkReceive_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

  SimpleNetwork Receive Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
;

EFI_STATUS
SimpleNetworkMode_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

  SimpleNetwork Mode Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
;

EFI_STATUS
SimpleNetworkTransmitPattern1_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

  SimpleNetwork TransmitPattern1 Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
;

EFI_STATUS
SimpleNetworkTransmitPattern2_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

  SimpleNetwork TransmitPattern2 Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
;

EFI_STATUS
SimpleNetworkReceivePattern1_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

  SimpleNetwork TransmitPattern3 Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
;

extern CHAR16         *gSimpleNetworkEntsRuntimeInfo;
extern UINTN          gSimpleNetworkEntsRuntimeInfoSize;

extern ENTS_ARG_FIELD gSimpleNetworkStartArgField[];
extern ENTS_ARG_FIELD gSimpleNetworkStopArgField[];
extern ENTS_ARG_FIELD gSimpleNetworkInitializeArgField[];
extern ENTS_ARG_FIELD gSimpleNetworkResetArgField[];
extern ENTS_ARG_FIELD gSimpleNetworkShutdownArgField[];
extern ENTS_ARG_FIELD gSimpleNetworkReceiveFiltersArgField[];
extern ENTS_ARG_FIELD gSimpleNetworkStationAddressArgField[];
extern ENTS_ARG_FIELD gSimpleNetworkStatisticsArgField[];
extern ENTS_ARG_FIELD gSimpleNetworkMCastIPToMACArgField[];
extern ENTS_ARG_FIELD gSimpleNetworkNvDataArgField[];
extern ENTS_ARG_FIELD gSimpleNetworkGetStatusArgField[];
extern ENTS_ARG_FIELD gSimpleNetworkTransmitArgField[];
extern ENTS_ARG_FIELD gSimpleNetworkReceiveArgField[];
extern ENTS_ARG_FIELD gSimpleNetworkModeArgField[];
extern ENTS_ARG_FIELD gSimpleNetworkTransmitPattern1ArgField[];
extern ENTS_ARG_FIELD gSimpleNetworkTransmitPattern2ArgField[];
extern ENTS_ARG_FIELD gSimpleNetworkReceivePattern1ArgField[];

#endif // _SIMPLENETWORK_ENTS_TESTCASE_H_
