/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:

  SctData.h

Abstract:

  This file provides the services to manage the test cases with the test
  execution.

--*/

#ifndef _EFI_SCT_DATA_EX_H_
#define _EFI_SCT_DATA_EX_H_

//
// External functions declaration
//

EFI_STATUS
SelectTestCase (
  IN EFI_GUID                     *Guid,
  IN UINT32                       Iterations
  );

EFI_STATUS
UnselectTestCase (
  IN EFI_GUID                     *Guid
  );

EFI_STATUS
GetTestCaseState (
  IN EFI_GUID                     *Guid,
  OUT EFI_SCT_TEST_STATE          *TestState
  );

UINT32
GetTestCaseOrder (
  IN EFI_GUID                     *Guid
  );

UINT32
GetTestCaseIterations (
  IN EFI_GUID                     *Guid
  );

UINT32
GetTestCasePasses (
  IN EFI_GUID                     *Guid
  );

UINT32
GetTestCaseWarnings (
  IN EFI_GUID                     *Guid
  );

UINT32
GetTestCaseFailures (
  IN EFI_GUID                     *Guid
  );

EFI_STATUS
GetRunningTestCase (
  OUT EFI_SCT_TEST_CASE           **TestCase
  );

EFI_STATUS
GetNextTestCase (
  OUT EFI_SCT_TEST_CASE           **TestCase
  );

EFI_STATUS
GetTestCaseRemainNum (
  UINTN                           *Remain
  );

BOOLEAN
IsTestFinished (
  VOID
  );

EFI_STATUS
ResetTestCaseOrder (
  VOID
  );

EFI_STATUS
ResetTestCaseResults (
  VOID
  );

EFI_STATUS
ResetTestCaseOrderAndResults (
  VOID
  );

EFI_STATUS
BuildTestCaseOrder (
  VOID
  );

#endif
